package com.logicbig.example;

import com.netflix.hystrix.contrib.javanica.annotation.HystrixCommand;
import com.netflix.hystrix.contrib.javanica.annotation.HystrixProperty;
import org.springframework.stereotype.Service;
import java.util.concurrent.TimeUnit;

@Service
public class MyService {
    @HystrixCommand(fallbackMethod = "defaultDoSomething",
    commandProperties = {
            @HystrixProperty(name = "circuitBreaker.requestVolumeThreshold", value = "2"),
            @HystrixProperty(name = "metrics.rollingStats.timeInMilliseconds", value = "500"),
            @HystrixProperty(name = "circuitBreaker.errorThresholdPercentage", value = "1"),
            @HystrixProperty(name = "circuitBreaker.sleepWindowInMilliseconds", value = "1000")

    })
    public void doSomething(int input) {
        System.out.println("output: " + 10 / input);
    }

    public void defaultDoSomething(int input, Throwable throwable) {
        System.out.printf("fallback, input:%s, exception:%s%n", input, throwable);
    }
}